#include <stdio.h>
#include <stdlib.h>
#include <spu_intrinsics.h>
#include <spu_mfcio.h>

#include "spe_poor.h"
// Ƃ肠A2048_炢... 8192 byte <- ꂪ5{
// 40960 byte == 40KB

#define MAX_BUFSIZE (2048*4)

float buf[MAX_BUFSIZE*5] __attribute__((aligned(16)));
spe_args_t args __attribute__((aligned(16)));

typedef struct problem_rt {
	vector float* mass;
	vector float* pos_x;
	vector float* pos_y;
	vector float* vel_x;
	vector float* vel_y;
} problem_rt_t;

static void calc_add_vellocity4(int focus_id, int effecton_id, float gc,
		int delta_t, problem_rt_t* prt);

int main(unsigned long long spe, unsigned long long argp,
		unsigned long long envp) {
	int tag = 1, i, j;
	mfc_list_element_t list[5];
	problem_rt_t prt;

	// ARGS ̓ǂݍ
	spu_mfcdma64(&args, mfc_ea2h(argp), mfc_ea2l(argp), sizeof(spe_args_t),
			tag, MFC_GET_CMD);
	spu_writech(MFC_WrTagMask, 1 << tag);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);

	// ǂݍ݃Xg̍쐬
	for (i = 0; i < 5; i++) {
		list[i].notify = 0;
		list[i].reserved = 0;
		list[i].size = args.aligned_buffer_size;
	}
	list[0].eal = mfc_ea2l(args.mass);
	list[1].eal = mfc_ea2l(args.pos_x);
	list[2].eal = mfc_ea2l(args.pos_y);
	list[3].eal = mfc_ea2l(args.vel_x);
	list[4].eal = mfc_ea2l(args.vel_y);

	// obt@̈̃xt
	prt.mass = (vector float*) &(buf[0]);
	prt.pos_x = (vector float*) &(buf[args.aligned_buffer_size]);
	prt.pos_y = (vector float*) &(buf[args.aligned_buffer_size *2]);
	prt.vel_x = (vector float*) &(buf[args.aligned_buffer_size *3]);
	prt.vel_y = (vector float*) &(buf[args.aligned_buffer_size *4]);

	// f[^ǂݍ
	spu_mfcdma64(buf, mfc_ea2h(args.mass), (unsigned int)&list, sizeof(list),
			0, MFC_GETL_CMD);
	spu_writech(MFC_WrTagMask, 1 << 0);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);

	
	// S̉xExvZ
	for (i = args.assigned_id_min; i < args.assigned_id_max; i+=4) {
		for (j = 0; j < args.nplots; j+=4) {
			calc_add_vellocity4(i/4, j/4, args.gc, args.delta_t, &prt);
		}
	}
	// S̈ʒuvZ
	for (i = args.assigned_id_min; i < args.assigned_id_max; i+=4) {
		(prt.pos_x)[i/4] = spu_madd((prt.vel_x)[i/4], spu_splats((float)args.delta_t), (prt.pos_x)[i/4]);
	}

	// ݃Xg̍쐬
	for (i = 0; i < 5; i++) {
		list[i].notify = 0;
		list[i].reserved = 0;
		list[i].size = (args.assigned_id_max - args.assigned_id_min)
				* sizeof(float);
	}
	list[0].eal = mfc_ea2l(args.mass) + args.assigned_id_min * sizeof(float);
	list[1].eal = mfc_ea2l(args.pos_x) + args.assigned_id_min * sizeof(float);
	list[2].eal = mfc_ea2l(args.pos_y) + args.assigned_id_min * sizeof(float);
	list[3].eal = mfc_ea2l(args.vel_x) + args.assigned_id_min * sizeof(float);
	list[4].eal = mfc_ea2l(args.vel_y) + args.assigned_id_min * sizeof(float);

	// f[^
	spu_mfcdma64(buf, mfc_ea2h(args.mass), (unsigned int)&list, sizeof(list),
			0, MFC_PUTL_CMD);
	spu_writech(MFC_WrTagMask, 1 << 0);
	spu_mfcstat(MFC_TAG_UPDATE_ALL);

	return EXIT_SUCCESS;
}

// x͉xvZɂ͕KvȂ̂ōXVł
static void calc_add_vellocity4(int focus_id, int effecton_id, float gc,
		int delta_t, problem_rt_t* prt) {
	vector float effecton_mass = prt->mass[effecton_id];
	vector float effecton_pos_x = prt->pos_x[effecton_id];
	vector float effecton_pos_y = prt->pos_y[effecton_id];
	vector float delta_x, delta_y, norm_squr, direction_x, direction_y,
			accel_x, accel_y;
	float dt = (float)delta_t;
	int i;

	//xvZ
	// m * a_vector = GmM / r_norm^2 * r_vector

	//4_̌ʓ_vẐŌʓ_FNg4Vtg
	//RgAEg̓XJZ
	for (i = 0; i < 4; i++) {
		// 
		//delta_x = pos_x[focus_id] - effecton_pos_x;
		//delta_y = pos_y[focus_id] - effecton_pos_y;
		delta_x = spu_sub((prt->pos_x)[focus_id], effecton_pos_x);
		delta_y = spu_sub((prt->pos_y)[focus_id], effecton_pos_y);
		//norm_squr = delta_x * delta_x + delta_y * delta_y;
		norm_squr = spu_madd(delta_x, delta_x, spu_mul(delta_y, delta_y));

		// ͂̋yԕ
		//direction_x = delta_x *  1/sqrt(norm_squr);
		//direction_y = delta_y *  1/sqrt(norm_squr);
		direction_x = spu_mul(delta_x, spu_rsqrte(norm_squr));
		direction_y = spu_mul(delta_y, spu_rsqrte(norm_squr));

		// xZo : {͂Aڑɑ邯ǁA₷悤ɂˁB
		//accel_x = gc * effecton_mass * 1/norm_squr * direction_x;
		//accel_y = gc * effecton_mass * 1/norm_squr * direction_y;
		accel_x = spu_mul(spu_splats(gc), spu_mul(effecton_mass,
				spu_mul(spu_rsqrte(norm_squr), direction_x)));
		accel_y = spu_mul(spu_splats(gc), spu_mul(effecton_mass,
				spu_mul(spu_rsqrte(norm_squr), direction_y)));

		// xZ
		// vel_x[focus_id] += accel_x * dt;
		// vel_y[focus_id] += accel_y * dt;
		(prt->vel_x)[focus_id] = spu_madd(accel_x, spu_splats(dt), (prt->vel_x)[focus_id]);
		(prt->vel_y)[focus_id] = spu_madd(accel_y, spu_splats(dt), (prt->vel_y)[focus_id]);

		// e_S_ƌvZ邽߂ɉe_FNgVtg
		effecton_mass = spu_rlqwbyte(effecton_mass, (int)sizeof(float));
		effecton_pos_x = spu_rlqwbyte(effecton_pos_x, (int)sizeof(float));
		effecton_pos_y = spu_rlqwbyte(effecton_pos_y, (int)sizeof(float));
	}

}

